Here are some floating point routines for the P2. There are 3 versions
of the float code: BinFloat.spin2 (32 bit floats), Double.spin2 (both 32 and 64 bit floats), and DecFloat.spin2 (32 bit decimal floats, 10 based).

Float Routines
--------------
BinFloat.spin2: IEEE binary float functions. Only handles 32 bit format.
  This has sin(), cos(), tan() and various decimal to binary conversion
  options.
  
DecFloat.spin2: decimal (base 10) floats. This is a fairly complete
  package including conversion from strings and trig functions.

Double.spin2: binary (base 2) floats, in both 32 and 64 bit versions.
  The 64 bit versions use (lo, hi) pairs to represent the values.
  This code was pulled out of the riscvp2 runtime, which in turn borrowed
  it from the P1 GCC library, so it has gone through many revisions and
  is ugly and convoluted. OTOH it works pretty well, or at least the
  version in riscvp2 did (it passed a bunch of floating point tests).
  Only basic arithmetic (+, -, *, /, sqrt) and a few conversions are
  implemented, trig and transcentals are not.

Test Programs
-------------

test_ieee32.spin2: test suite for IEEE binary floats
  Based on the Sun / UC Berkeley IEEE test programs, and hence has
  good coverage of edge cases and tricky stuff.

testdouble.spin2: test program for Double.spin2. Only does a few simple
  calculations. It did turn up a bug in PNut (the representation of
  3.1 is off by 1 bit).

testdec.spin2: A simple test program for DecFloat. Not very comprehensive,
  but verifies some basic things.

testbin.spin2: A simple test program for IEEE binary floats,
  work in progress. Two tests are failing, I think due to the
  decimal <-> binary conversion routines, but I'm not certain of this
  now.


Support Files
-------------
testdiv.spin2: timing test for divide by 10 routines

ers_fmt.spin2: simple integer formatting for SEND (from the OBEX)
SmartSerial.spin2: simple serial with smart pins
